Debian Bug report logs - #317900
ecasound freezes the computer under root with double buffering

version graph

Package: ecasound; Maintainer for ecasound is Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>; Source for ecasound is src:ecasound.

Reported by: Skliarouk Arieh <arieh@tkos.co.il>

Date: Tue, 12 Jul 2005 10:48:02 UTC

Severity: normal

Tags: fixed

Found in version 2.4.0-1

Fixed in version ecasound/2.4.3-1

Done: Junichi Uekawa <dancer@netfort.gr.jp>

Bug is archived. No further changes may be made.

Forwarded to ecasound-list@lists.sourceforge.net

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Junichi Uekawa <dancer@debian.org>:
Bug#317900; Package ecasound. Full text and rfc822 format available.

Acknowledgement sent to Skliarouk Arieh <arieh@tkos.co.il>:
New Bug report received and forwarded. Copy sent to Junichi Uekawa <dancer@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Skliarouk Arieh <arieh@tkos.co.il>
To: submit@bugs.debian.org
Cc: Tom Rosenfeld <tom@catchmedia.com>
Subject: ecasound freezes the computer under root with double buffering
Date: Tue, 12 Jul 2005 13:32:39 +0300
package: ecasound
version: 2.4.0-1

Hello,

If ecasound runs with double buffering and under root, almost any kind 
of termination of the process causes complete computer freeze:
/usr/bin/ecasound -b:4096 -z:db,661500 -r:99 -f:16,2,44100,i -i 
alsahw,0,0 -o stdout

It exits properly, if I stop it as follows:
killall -STOP ecasound; killall -KILL ecasound

Another way to stop ecasound safely is to run it with tee like this:
/usr/bin/ecasound -b:4096 -z:db,661500 -r:99 -f:16,2,44100,i -i 
alsahw,0,0 -o stdout | tee audio.raw > /dev/null

And then kill the processes in following order and with following delay:
killall -9 tee; sleep 1; killall -9 ecasound

Looks like ecasound does not tolerate any signal when it is in system 
call (read kernel mode) of any kind.

---
Bye,  | Phone: (972)-2-6795364
Arieh | Fax:   (972)-2-6796453




Reply sent to Junichi Uekawa <dancer@netfort.gr.jp>:
You have marked Bug as forwarded. Full text and rfc822 format available.

Message #8 received at 317900-forwarded@bugs.debian.org (full text, mbox):

From: Junichi Uekawa <dancer@netfort.gr.jp>
To: ecasound-list@lists.sourceforge.net
Cc: Skliarouk Arieh <arieh@tkos.co.il>, 317900-forwarded@bugs.debian.org, Tom Rosenfeld <tom@catchmedia.com>
Subject: Re: Bug#317900: ecasound freezes the computer under root with double buffering
Date: Wed, 13 Jul 2005 01:57:38 +0900
Hi,

I received the following report for Debian package.

It sounds possible, considering the privilege it is running under,
but nasty.


> If ecasound runs with double buffering and under root, almost any kind 
> of termination of the process causes complete computer freeze:
> /usr/bin/ecasound -b:4096 -z:db,661500 -r:99 -f:16,2,44100,i -i 
> alsahw,0,0 -o stdout
> 
> It exits properly, if I stop it as follows:
> killall -STOP ecasound; killall -KILL ecasound
> 
> Another way to stop ecasound safely is to run it with tee like this:
> /usr/bin/ecasound -b:4096 -z:db,661500 -r:99 -f:16,2,44100,i -i 
> alsahw,0,0 -o stdout | tee audio.raw > /dev/null
> 
> And then kill the processes in following order and with following delay:
> killall -9 tee; sleep 1; killall -9 ecasound
> 
> Looks like ecasound does not tolerate any signal when it is in system 
> call (read kernel mode) of any kind.



regards,
	junichi



Message #9 received at 317900-forwarded@bugs.debian.org (full text, mbox):

From: Kai Vehmanen <kvehmanen@eca.cx>
To: Junichi Uekawa <dancer@netfort.gr.jp>
Cc: ecasound-list@lists.sourceforge.net, Skliarouk Arieh <arieh@tkos.co.il>, 317900-forwarded@bugs.debian.org, Tom Rosenfeld <tom@catchmedia.com>
Subject: Re: [ecasound] Re: Bug#317900: ecasound freezes the computer under root with double buffering
Date: Tue, 12 Jul 2005 23:05:09 +0300 (EEST)
Hello all,

On Wed, 13 Jul 2005, Junichi Uekawa wrote:

> It sounds possible, considering the privilege it is running under,
> but nasty.
[...]
>> If ecasound runs with double buffering and under root, almost any kind
>> of termination of the process causes complete computer freeze:
>> /usr/bin/ecasound -b:4096 -z:db,661500 -r:99 -f:16,2,44100,i -i
>> alsahw,0,0 -o stdout

couple of notes:
- -r:99 is very extreme and dangerous, please use the default "-r"
  or just a lower value like "-r:40"
- -z:db,661500 is a _lot_ of buffering (15secs of audio at 44.1kHz),
   but might be needed on some machines

And then a couple of questions:

- which version of ecasound? (if old 2.0.x release, please upgrade
  to newer 2.2 (in sarge) and retry the tests, 2.0.x is really old
  and not supported anymore)
- which soundcard...? the problem description sounds like a driver
  problem (running with -r, i.e. SCHED_FIFO scheduling, can turn
  a minor driver bug into a system-freeze type of problem)

I've tested the above configuration myself on multiple machines and no
freezes so far, no matter what I try.

>> It exits properly, if I stop it as follows:
>> killall -STOP ecasound; killall -KILL ecasound
>>
>> Another way to stop ecasound safely is to run it with tee like this:
>> /usr/bin/ecasound -b:4096 -z:db,661500 -r:99 -f:16,2,44100,i -i
>> alsahw,0,0 -o stdout | tee audio.raw > /dev/null

Hmm, this is interesting. The signal handling has been changed
a few times since 2.0.x -- if you are running 2.0.x, that might
explain the problem. Otherwise further investigation is definitely
needed. The bad news is that tracking down SCHED_FIFO-triggere problems
can be very difficult.. :(

>> Looks like ecasound does not tolerate any signal when it is in system
>> call (read kernel mode) of any kind.

This should not be the case. The signal handler is designed to be
real-time safe, and should be able to cleanly shutdown the engine in all 
possible cases. But, but, obviously something goes badly wrong in your 
case...

-- 
 http://www.eca.cx
 Audio software for Linux!



Message #10 received at 317900-forwarded@bugs.debian.org (full text, mbox):

From: Skliarouk Arieh <arieh@tkos.co.il>
To: Kai Vehmanen <kvehmanen@eca.cx>
Cc: Junichi Uekawa <dancer@netfort.gr.jp>, ecasound-list@lists.sourceforge.net, 317900-forwarded@bugs.debian.org, Tom Rosenfeld <tom@catchmedia.com>
Subject: Re: [ecasound] Re: Bug#317900: ecasound freezes the computer under root with double buffering
Date: Thu, 14 Jul 2005 14:36:36 +0300
Hello,

> - which version of ecasound? (if old 2.0.x release, please upgrade

ecasound of version 2.4.1-1.

> - which soundcard...? the problem description sounds like a driver

The problem is 100% reproduceable on following two cards
Card: SiS SI7012
Chip: Analog Devices AD1980

Card: SiS SI7012
Card: Realtek ALC655 rev 0

Well, I suspected that the problem is in realtime somewhere. I really 
need all these 15seconds of buffer, and highest possible priority (as 
not to lose even single tick of audio).

Close the bug, as workaround that I found works for me, and I see that 
not many are bited by the bug.

Thanks for spending time on the bug!

-
Arieh

Kai Vehmanen wrote:

> Hello all,
>
> On Wed, 13 Jul 2005, Junichi Uekawa wrote:
>
>> It sounds possible, considering the privilege it is running under,
>> but nasty.
>
> [...]
>
>>> If ecasound runs with double buffering and under root, almost any kind
>>> of termination of the process causes complete computer freeze:
>>> /usr/bin/ecasound -b:4096 -z:db,661500 -r:99 -f:16,2,44100,i -i
>>> alsahw,0,0 -o stdout
>>
>
> couple of notes:
> - -r:99 is very extreme and dangerous, please use the default "-r"
>   or just a lower value like "-r:40"
> - -z:db,661500 is a _lot_ of buffering (15secs of audio at 44.1kHz),
>    but might be needed on some machines
>
> And then a couple of questions:
>
> - which version of ecasound? (if old 2.0.x release, please upgrade
>   to newer 2.2 (in sarge) and retry the tests, 2.0.x is really old
>   and not supported anymore)
> - which soundcard...? the problem description sounds like a driver
>   problem (running with -r, i.e. SCHED_FIFO scheduling, can turn
>   a minor driver bug into a system-freeze type of problem)
>
> I've tested the above configuration myself on multiple machines and no
> freezes so far, no matter what I try.
>
>>> It exits properly, if I stop it as follows:
>>> killall -STOP ecasound; killall -KILL ecasound
>>>
>>> Another way to stop ecasound safely is to run it with tee like this:
>>> /usr/bin/ecasound -b:4096 -z:db,661500 -r:99 -f:16,2,44100,i -i
>>> alsahw,0,0 -o stdout | tee audio.raw > /dev/null
>>
>
> Hmm, this is interesting. The signal handling has been changed
> a few times since 2.0.x -- if you are running 2.0.x, that might
> explain the problem. Otherwise further investigation is definitely
> needed. The bad news is that tracking down SCHED_FIFO-triggere problems
> can be very difficult.. :(
>
>>> Looks like ecasound does not tolerate any signal when it is in system
>>> call (read kernel mode) of any kind.
>>
>
> This should not be the case. The signal handler is designed to be
> real-time safe, and should be able to cleanly shutdown the engine in 
> all possible cases. But, but, obviously something goes badly wrong in 
> your case...
>




Message #11 received at 317900-forwarded@bugs.debian.org (full text, mbox):

From: Kai Vehmanen <kvehmanen@eca.cx>
To: Skliarouk Arieh <arieh@tkos.co.il>
Cc: Junichi Uekawa <dancer@netfort.gr.jp>, 317900-forwarded@bugs.debian.org, Tom Rosenfeld <tom@catchmedia.com>
Subject: Re: [ecasound] Re: Bug#317900: ecasound freezes the computer under root with double buffering
Date: Sat, 20 Aug 2005 16:59:01 +0300 (EEST)
Hello all,

I think I've now been able to reproduce this bug, and make a fix for the 
problem. Could you please try the following snapshot and report back to me 
whether it works or not:

http://ecasound.seul.org/download/snapshots/ecasound-2.4.3-cvs-20050820b.tar.gz


On Thu, 14 Jul 2005, Skliarouk Arieh wrote:

> Hello,
>
>> - which version of ecasound? (if old 2.0.x release, please upgrade
>
> ecasound of version 2.4.1-1.
>
>> - which soundcard...? the problem description sounds like a driver
>
> The problem is 100% reproduceable on following two cards
> Card: SiS SI7012
> Chip: Analog Devices AD1980
>
> Card: SiS SI7012
> Card: Realtek ALC655 rev 0
>
> Well, I suspected that the problem is in realtime somewhere. I really need 
> all these 15seconds of buffer, and highest possible priority (as not to lose 
> even single tick of audio).
>
> Close the bug, as workaround that I found works for me, and I see that not 
> many are bited by the bug.
>
> Thanks for spending time on the bug!
>
> -
> Arieh
>
> Kai Vehmanen wrote:
>
>> Hello all,
>> 
>> On Wed, 13 Jul 2005, Junichi Uekawa wrote:
>> 
>>> It sounds possible, considering the privilege it is running under,
>>> but nasty.
>> 
>> [...]
>> 
>>>> If ecasound runs with double buffering and under root, almost any kind
>>>> of termination of the process causes complete computer freeze:
>>>> /usr/bin/ecasound -b:4096 -z:db,661500 -r:99 -f:16,2,44100,i -i
>>>> alsahw,0,0 -o stdout
>>> 
>> 
>> couple of notes:
>> - -r:99 is very extreme and dangerous, please use the default "-r"
>>   or just a lower value like "-r:40"
>> - -z:db,661500 is a _lot_ of buffering (15secs of audio at 44.1kHz),
>>    but might be needed on some machines
>> 
>> And then a couple of questions:
>> 
>> - which version of ecasound? (if old 2.0.x release, please upgrade
>>   to newer 2.2 (in sarge) and retry the tests, 2.0.x is really old
>>   and not supported anymore)
>> - which soundcard...? the problem description sounds like a driver
>>   problem (running with -r, i.e. SCHED_FIFO scheduling, can turn
>>   a minor driver bug into a system-freeze type of problem)
>> 
>> I've tested the above configuration myself on multiple machines and no
>> freezes so far, no matter what I try.
>> 
>>>> It exits properly, if I stop it as follows:
>>>> killall -STOP ecasound; killall -KILL ecasound
>>>> 
>>>> Another way to stop ecasound safely is to run it with tee like this:
>>>> /usr/bin/ecasound -b:4096 -z:db,661500 -r:99 -f:16,2,44100,i -i
>>>> alsahw,0,0 -o stdout | tee audio.raw > /dev/null
>>> 
>> 
>> Hmm, this is interesting. The signal handling has been changed
>> a few times since 2.0.x -- if you are running 2.0.x, that might
>> explain the problem. Otherwise further investigation is definitely
>> needed. The bad news is that tracking down SCHED_FIFO-triggere problems
>> can be very difficult.. :(
>> 
>>>> Looks like ecasound does not tolerate any signal when it is in system
>>>> call (read kernel mode) of any kind.
>>> 
>> 
>> This should not be the case. The signal handler is designed to be
>> real-time safe, and should be able to cleanly shutdown the engine in all 
>> possible cases. But, but, obviously something goes badly wrong in your 
>> case...
>>

--
 links, my public keys, etc at http://eca.cx/kv



Message #12 received at 317900-forwarded@bugs.debian.org (full text, mbox):

From: Skliarouk Arieh <arieh@tkos.co.il>
To: Kai Vehmanen <kvehmanen@eca.cx>
Cc: Junichi Uekawa <dancer@netfort.gr.jp>, 317900-forwarded@bugs.debian.org, Tom Rosenfeld <tom@catchmedia.com>
Subject: Re: Bug#317900: ecasound freezes the computer under root with double buffering
Date: Sun, 21 Aug 2005 18:22:43 +0300
Hello,

>> If ecasound runs with double buffering and under root, almost any kind
>> of termination of the process causes complete computer freeze:
>> /usr/bin/ecasound -b:4096 -z:db,661500 -r:99 -f:16,2,44100,i -i
>> alsahw,0,0 -o stdout
>
> I think I've now been able to reproduce this bug, and make a fix for 
> the problem. Could you please try the following snapshot and report 
> back to me whether it works or not:
>
> http://ecasound.seul.org/download/snapshots/ecasound-2.4.3-cvs-20050820b.tar.gz 


I tested the snapshot and indeed, it does not crash the computer no 
matter how I terminate it.

You can package it up and then close the bug.

Thank you!

---
Bye,  | Phone: (972)-2-6795364
Arieh | Fax:   (972)-2-6796453





Message #13 received at 317900-forwarded@bugs.debian.org (full text, mbox):

From: Kai Vehmanen <kvehmanen@eca.cx>
To: Skliarouk Arieh <arieh@tkos.co.il>
Cc: Kai Vehmanen <kvehmanen@eca.cx>, Junichi Uekawa <dancer@netfort.gr.jp>, 317900-forwarded@bugs.debian.org, Tom Rosenfeld <tom@catchmedia.com>
Subject: Re: Bug#317900: ecasound freezes the computer under root with double buffering
Date: Sun, 21 Aug 2005 18:41:35 +0300 (EEST)
On Sun, 21 Aug 2005, Skliarouk Arieh wrote:

>>> If ecasound runs with double buffering and under root, almost any kind
>>> of termination of the process causes complete computer freeze:
>>
>> I think I've now been able to reproduce this bug, and make a fix for the 
>> problem. Could you please try the following snapshot and report back to me 
>> whether it works or not:
>> 
>> http://ecasound.seul.org/download/snapshots/ecasound-2.4.3-cvs-20050820b.tar.gz 
>>
> I tested the snapshot and indeed, it does not crash the computer no matter 
> how I terminate it.
>
> You can package it up and then close the bug.

Ok, great, thanks for testing! I'll be releasing 2.4.3 soon, so you might 
want to wait for that (contains a few other important fixes).

--
 links, my public keys, etc at http://eca.cx/kv



Message #14 received at 317900-forwarded@bugs.debian.org (full text, mbox):

From: Kai Vehmanen <kvehmanen@eca.cx>
To: Skliarouk Arieh <arieh@tkos.co.il>
Cc: Junichi Uekawa <dancer@netfort.gr.jp>, 317900-forwarded@bugs.debian.org, Tom Rosenfeld <tom@catchmedia.com>
Subject: Re: Bug#317900: ecasound freezes the computer under root with double buffering
Date: Sun, 21 Aug 2005 23:07:58 +0300 (EEST)
Hi,

Ecasound v2.4.3 with the bug fixed was released today. Full release notes
available at:

  http://eca.cx/relnotes/ecasound_v2_4_3_relnotes.txt

Thanks for the bughunting help!


On Sun, 21 Aug 2005, Skliarouk Arieh wrote:

> Hello,
>
>>> If ecasound runs with double buffering and under root, almost any kind
>>> of termination of the process causes complete computer freeze:
>>> /usr/bin/ecasound -b:4096 -z:db,661500 -r:99 -f:16,2,44100,i -i
>>> alsahw,0,0 -o stdout
>> 
>> I think I've now been able to reproduce this bug, and make a fix for the 
>> problem. Could you please try the following snapshot and report back to me 
>> whether it works or not:
>> 
>> http://ecasound.seul.org/download/snapshots/ecasound-2.4.3-cvs-20050820b.tar.gz 
>
>
> I tested the snapshot and indeed, it does not crash the computer no matter 
> how I terminate it.
>
> You can package it up and then close the bug.
>
> Thank you!
>
> ---
> Bye,  | Phone: (972)-2-6795364
> Arieh | Fax:   (972)-2-6796453
>
>

--
 links, my public keys, etc at http://eca.cx/kv



Tags added: fixed Request was from Anibal Monsalve Salazar <anibal@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Bug marked as fixed in version 2.4.3-1, send any further explanations to Skliarouk Arieh <arieh@tkos.co.il> Request was from Junichi Uekawa <dancer@netfort.gr.jp> to control@bugs.debian.org. Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 21 Dec 2009 07:29:08 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 25 07:38:37 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.